Unit DGWidgets;

{$F+}
{$O+}

Interface

Uses
 Crt, Dos, Strings, Graph, ms_mouse;

Const
 On  =  1;
 Off =  0;

Type

 PPushButton = ^TPushButton;
 TPushButton = object
  private:
   X1,Y1,X2,Y2,Status:Integer;
   Title:String;
   procedure Draw;
   procedure StatusDo;
  public:
   procedure setData(X1,Y1,X2,Y2:Integer; Title:String);
   function Check():integer;
 End;

 PLineEditField = ^TLineEditField;
 TLineEditField = object
  private:
   X1,Y1,X2,Y2:Integer;
   Text:PChar;
   procedure Draw;
   procedure StatusDo;
  public:
   procedure setData(X1,Y1,X2,Y2:Integer);
   function Check():string;
 End;

Implementation

{---------------------------------------------------------------------}
Procedure TPushButton.Draw(X1,Y1,X2,Y2:Integer; Title:String)

 Var
  bt,w,t,x,y:Word;
  C:Char;
  XX1,XX2,YY1,YY2:Integer;

 Begin
  hide_cursor;
  SetColor(8); Line(X1,Y2,X2,Y2); Line(X2,Y1,X2,Y2);
  SetColor(15); Line(X1,Y1,X1,Y2); Line(X1,Y1,X2,Y1);
  SetColor(7); Rectangle(X1+1,Y1+1,X2-1,Y2-1);
  SetFillStyle(1,7); FloodFill(X1+4,Y1+4,7);
  SetTextStyle(DefaultFont,HorizDir,1);
  SetTextJustify(CenterText, CenterText);
  SetColor(0);
  OutTextXY(((X2-X1)Div 2)+X1,((Y2-Y1)Div 2)+Y1,Title);
  show_cursor;
 End;

{---------------------------------------------------------------------}

Procedure TPushButton.StatusDo;
     Begin
     var
      x,y,bt:integer;
     x:=0; y:=0; bt:=0;
     read_status(x,y,bt);
     If (bt = 1) And (x > X1) And (x < X2) And (y > Y1) And (y < Y2) Then
      Begin
      hide_cursor;
      SetColor(7); Rectangle(X1+1,Y1+1,X2-1,Y2-1);
      SetColor(15); Line(X1,Y2,X2,Y2); Line(X2,Y1,X2,Y2);
      SetColor(8); Line(X1,Y1,X1,Y2); Line(X1,Y1,X2,Y1);
      Case Status Of
       1:Status:=0;
       0:Status:=1;
      End;
      show_cursor;
      bt:=0;
      Repeat
      read_status(x,y,bt);
      Until bt <> 1;
     hide_cursor;
     SetColor(7); Rectangle(X1+1,Y1+1,X2-1,Y2-1);
     SetColor(8); Line(X1,Y2,X2,Y2); Line(X2,Y1,X2,Y2);
     SetColor(15); Line(X1,Y1,X1,Y2); Line(X1,Y1,X2,Y1);
     show_cursor;
     End;
{---------------------------------------------------------------------}
Function TPushButton.Check:integer;
 Begin
  StatusDo;
  If Status:=On then
   Check:=On
  Else
   Check:=Off;
 End;
{---------------------------------------------------------------------}
 Procedure TLineEditField.Draw(X1,X2,Y:Integer);

  Begin
    SetFillStyle(1,15);
    Bar(X1,Y,X2,Y+20);
    SetColor(8);
    Rectangle(X1,Y,X2,Y+20);
    LEData[1].X1:=X1; LEData[1].X2:=X2; LEData[1].Y:=Y;
  End;
{---------------------------------------------------------------------}

 Procedure TLineEditField.StatusDo;

  Var
    I,J:Integer;
    CH,C:PChar;

  Begin
    bt:=0;
    read_status(x,y,bt);
    For J:=1 To 20 Do
    Begin
    If (bt=1) And (x >  X1) And (x <  X2)
    And (y >  Y) And (y <  Y+20) Then
     Begin
      hide_cursor;
      I:=1;
       Text:='';
      SetFillStyle(1,15);
      Bar( X1, Y, X2, Y+20);
      SetColor(2);
      Rectangle( X1, Y, X2, Y+20);
      Repeat
       CH^:=ReadKey;
       Begin
        Case CH^ of
         Chr(13): C^:='';
         Chr(8) : If(I>1) Then
                  Begin
                   Dec(I);
                   Bar((( X1+4)+8*(I-1))+5, Y+2, X2-2, Y+18);
                  End;
        Else
         If (I<(( X2- X1)Div(8))) Then
         Begin
          Inc(I);
          SetTextStyle(DefaultFont,HorizDir,1);
          SetColor(0);
          OutTextXY(( X1+4)+8*(I-1), Y+12,CH^);
          StrCat( Text,CH);
         End;
       End;
       End;
      Until (C^ ='');
      SetColor(8);
      Rectangle( X1, Y, X2, Y+20);
      show_cursor;
     End;
    End;
  End;
{---------------------------------------------------------------------}
Function TPushButton.Check:PChar;
 Begin
  StatusDo;
  Check:=LEData.text;
 End;
{---------------------------------------------------------------------}

end.
